
fl

\ 0 wconstant _data
10 wconstant _cs         \ P16
11 wconstant _rs         \ P17
12 wconstant _wr         \ P18
13 wconstant _rd         \ P19
14 wconstant _reset      \ P20

1 _cs lshift constant _csm 
1 _rs lshift constant _rsm
1 _wr lshift constant _wrm
1 _rd lshift constant _rdm
1 _reset lshift constant _resetm

{
: _data_out _data 10 0 do dup pinout 1+ loop drop ;
: _cs_out _cs pinout ;
: _rs_out _rs pinout ;
: _wr_out _wr pinout ;
: _rd_out _rd pinout ;
: _reset_out _reset pinout ;
}

: _cs_l _csm _maskoutlo ;
: _cs_h _csm _maskouthi ;
: _rs_l _rsm _maskoutlo ;
: _rs_h _rsm _maskouthi ;
: _wr_l _wrm _maskoutlo ;
: _wr_h _wrm _maskouthi ;
: _rd_l _rdm _maskoutlo ;
: _rd_h _rdm _maskouthi ;
: _reset_l _resetm _maskoutlo ;
: _reset_h _resetm _maskouthi ;

: lcd_out
_cs_l _rs_l ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _rs_h    \ write register index
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _cs_h          \ write register data
;

: lcd_out_gram
_cs_l _rs_l ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _rs_h    \ write register index (write)
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h                \ write 1st data
ffff0000 outa COG@ and or outa COG! _wr_l _wr_h _cs_h          \ write 2nd data
;

: YHY024006A_init
0 15 0 do dup pinout 1+ loop drop		\ P0 - P20 output set
14 delms       \ wait 20msec
\ _cs_out _rs_out _wr_out _rd_out _reset_out
_cs_h _rs_h _rd_h _wr_h _reset_h    \ cs=rs=wr=rd=reset=H 
5 delms        \ wait 5msec
_reset_l
10 delms
_reset_h
14 delms

\ 3008 e3   lcd_out   \ internal timing   
\ 12 e7     lcd_out   \ internal timing
\ 1231 ef   lcd_out   \ internal timing
0 1       lcd_out   \ SS and SM
700 2     lcd_out   \ 1line inversion
c030 3    lcd_out   \ GRAM eritr derection / set RGB(BGR=0)
0 4       lcd_out   \ resize
207 8     lcd_out   \ back porch and front porch
0 9       lcd_out   \ 
0 a       lcd_out
0 c       lcd_out
0 d       lcd_out
0 f       lcd_out

0 10      lcd_out
7 11      lcd_out
0 12      lcd_out
0 13      lcd_out
c8 delms
1490 10   lcd_out
227 11    lcd_out
32 delms
1c 12     lcd_out
32 delms
a00 13    lcd_out
f 29      lcd_out
d 2b      lcd_out
32 delms
0 20      lcd_out
0 21      lcd_out

0 30      lcd_out
203 31    lcd_out
1 32      lcd_out
205 35    lcd_out
20c 366   lcd_out
07 37     lcd_out
405 38    lcd_out
707 39    lcd_out
502 3c    lcd_out
1008 3d   lcd_out

0 50      lcd_out
ef 51     lcd_out
0 52      lcd_out
13f 53    lcd_out
a700 60   lcd_out
1 61      lcd_out
0 6a      lcd_out

0 80      lcd_out
0 81      lcd_out
0 82      lcd_out
0 83      lcd_out
0 84      lcd_out
0 85      lcd_out

10 90     lcd_out
600 92    lcd_out
\ 3 93      lcd_out
\ 110 95    lcd_out
\ 0 97      lcd_out
\ 0 98      lcd_out

133 7     lcd_out
;

: color_data                      \ B(6bit)G(6bit)R(6bit) --> 2nd data(16bit) 1st data(2bit)
swap 6 lshift or over f and c lshift or swap 4 rshift
22 lcd_out_gram
;

: demo
YHY024006A_init
 f0 0 do 
     140 0 do
              0 3f 3f color_data     \ botom:B center:G top:R
     loop
 loop
     

;


